package com.simonstl.midp.tam;

/*
* This interface is placed in the public domain by Simon St.Laurent.
 */
/**
 *
 * A subset of the SAX2 Attributes interface.  Since there's no reading of the DTD,
 * the getType method has been removed and a getContainsSkippedEntity method added.
 *
 * 
 *
 * @author  simonstl
 */
public interface TamAttributes {
    
    int getIndex(String uri, String localName);
    
    int getLength();
    
    String getLocalName(int index);
    
    String getQName(int index);
    
    String getPrefix(int index);
    
    String getUri(int index);
    
    String getValue(int index);
    
    String getValue(String uri, String localName);
    
    /**
     *  Added because TAM processors are not required to read DTDs.
     *  If this is true, the entity reference will be left in place in the
     *  attribute value.
     */
    boolean getContainsSkippedEntity(int index);
    
    /**
     *  Added because TAM processors are not required to read DTDs.
     *  If this is true, the entity reference will be left in place in the
     *  attribute value.
     */
    boolean getContainsSkippedEntity(String uri, String localName);
}
