package com.simonstl.midp.xml;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

import com.simonstl.midp.tam.*; 

/**
 * An implementation of {@link com.simonstl.midp.xml.TAMName TAMName} that adds
 * a space for the value of the attribute.  It also supports a property so that
 * entities that aren't understood by the parser can be noted.
 *
 * @author  simonstl
 */
public class TAMAttribute extends TAMName {
       
    protected String value ="";
    protected boolean quotes=true; //double quotes
    protected boolean containsSkippedEntity=false;
    
    /** Creates a new instance of TAMAttribute */
    public TAMAttribute() {
    }
    
   public String getValue() {
        return value;
    }
    
    public void setValue(String _value) {
        value=_value;
    }
    
    public void setQuotes(boolean _quotes){
        quotes=_quotes;
    }
    
    public boolean getQuotes(){
        return quotes;
    }
    
    public boolean getContainsSkippedEntity(){
        return containsSkippedEntity;
    }
    
    public void setContainsSkippedEntity(boolean _contains){
        containsSkippedEntity=_contains;
    }
}