package com.simonstl.midp.xml;


import java.util.Hashtable;
import java.util.Vector;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* Derived from the com.simonstl.moe.NamespaceContext class.
*
* @version 0.03 12 August 2002
* @author Simon St.Laurent
*/
public class TAMNSContext {

protected int level=0;
protected boolean modified=true;
protected Vector namespaceStack=new Vector();
protected Hashtable nsByPrefix;


public void declarePrefix (String prefix, String URI){
   TAMNSName nsName=new TAMNSName();
   nsName.setLocalName(prefix);
   nsName.setValue(URI);
//System.out.println(prefix+" = "+ URI);
   declarePrefix(nsName);
}

public void declarePrefix (TAMNSName namespace){
   modified=true;
   namespace.setLevel(level);
   namespaceStack.addElement(namespace);
}

protected void generateSets(){

   nsByPrefix=new Hashtable();

   int size=namespaceStack.size();
//System.out.println(getLevel());
  for (int i=0; i<size; i++){
      TAMNSName next=(TAMNSName) namespaceStack.elementAt(i);

//System.out.println(next.getLocalName() +"="+ next.getValue());
      nsByPrefix.put(next.getLocalName(), next);
      
   }//end for


}


public String getUri(String prefix){
   String returnVal=null;
   if (modified) { generateSets(); 
//System.out.println("getting URI from new set");
   }
   TAMNSName match=(TAMNSName) nsByPrefix.get(prefix);
//System.out.println("getting URI matching "+prefix);
   if (match!=null) {returnVal=match.getValue();}
//System.out.println(returnVal);
   return returnVal;
}


public void pushLevel() {
   level++;
}

public void popLevel() {
    
   level--;
   //remove declarations from end of list
   removeNamespaces(level);
}

protected boolean removeNamespaces(int removeLevel){

//removes last in list if level>removeLevel
//returns true when removal happens
//recurses back until false
//returns false at end.  popLevel() will always get a false back.

boolean returnVal=false;

int size=namespaceStack.size();
//System.out.println(size);

if (size>0) {
  size--;
  TAMNSName current=(TAMNSName) namespaceStack.elementAt(size);

  if (current.getLevel() > removeLevel) {
    namespaceStack.removeElementAt(size);
    returnVal=removeNamespaces (removeLevel);

  }

}
   
return returnVal;

}

public int getLevel(){
   return level;
}

public void reset() {
   level=0;
   modified=true;
   namespaceStack=new Vector();
}



/*
public static void printPush(NamespaceContext subject){
   System.out.println("Current level: "+subject.getLevel());
   subject.pushLevel();
   System.out.println("Pushed to level: "+subject.getLevel());
}

public static void printPop(NamespaceContext subject){
   System.out.println("Current level: "+subject.getLevel());
   subject.popLevel();
   System.out.println("Popped to level: "+subject.getLevel());
}

public static boolean test(){
   boolean returnVal=true;

   NamespaceContext subject=new NamespaceContext();

   subject.declarePrefix("test", "http://www.example.com");

   for (int i=0; i<7; i++){
     printPush(subject);
   }

   subject.declarePrefix("zap", "http://www.example.com/zap");
   subject.declarePrefix("zip", "http://www.example.com/zip");
   
   System.out.println(subject.getFullDeclaration());

   printPush(subject);
   subject.declarePrefix("zap", "http://www.zap.com");

   boolean testDeclared=subject.isDeclared("zap", "http://www.zap.com");

   System.out.println("Result of successful declaration test was: "+testDeclared);

   testDeclared=subject.isDeclared("zap", "http://www.example.com/zap");

   System.out.println("Result of wrong declaration test was: "+testDeclared);

   System.out.println(subject.getFullDeclaration());

   printPush(subject);

   printPop(subject);
   printPop(subject);
   System.out.println(subject.getFullDeclaration());

   testDeclared=subject.isDeclared("zap", "http://www.example.com/zap");

   System.out.println("Result of corrected wrong declaration test was: "+testDeclared);

   for (int i=0; i<4; i++){
     printPop(subject);
     System.out.println(subject.getFullDeclaration());
   }

   return returnVal;
}

public static void main(String[] args){
  boolean test=test();
  System.out.println("Result was "+test);
}
*/
}